#include <iprt/bldprog-strtab.h>

static const char g_achStrTabOidDbStrTab[] =
{
/* 0x00000 = "pkcs9ExtendedCertificateAttributes" */
    '\x85','E','x','t','e','n','d','e','d','C','e','r','t','i','f','i','c','a','t','e','A','t','t','r','i','b','u','t','e','s',
/* 0x0001e = "idceKeyUsageRestriction-Deprecated" */
    '\x8b','\x95','\x97','\x9e','R','e','s','t','r','i','c','t','i','o','n','-','D','e','p','r','e','c','a','t','e','d',
/* 0x00038 = "public-key-infrastructure" */
    'p','u','b','l','i','c','-','k','e','y','-','i','n','f','r','a','s','t','r','u','c','t','u','r','e',
/* 0x00051 = "MsQualifiedSubordination" */
    '\x87','Q','u','a','l','i','f','i','e','d','S','u','b','o','r','d','i','n','a','t','i','o','n',
/* 0x00068 = "MsSpcStructuredStorageData" */
    '\x87','\x90','S','t','r','u','c','t','u','r','e','d','S','t','o','r','a','g','e','D','a','t','a',
/* 0x0007f = "MsSpcFinacialCriterialInfo" */
    '\x87','\x90','F','i','n','a','c','i','a','l','C','r','i','t','e','r','i','a','l','I','n','f','o',
/* 0x00096 = "idkpSBGPCertAAServiceAuth" */
    '\x8b','\xa1','S','B','G','P','C','e','r','t','A','A','S','e','r','v','i','c','e','A','u','t','h',
/* 0x000ad = "idcePrivateKeyUsagePeriod" */
    '\x8b','\x95','P','r','i','v','a','t','e','K','e','y','U','s','a','g','e','P','e','r','i','o','d',
/* 0x000c4 = "MsSpcIndividualCodeSigning" */
    '\x87','\x90','I','n','d','i','v','i','d','u','a','l','C','o','d','e','S','i','g','n','i','n','g',
/* 0x000db = "MsSpcMinimalCriterialInfo" */
    '\x87','\x90','M','i','n','i','m','a','l','C','r','i','t','e','r','i','a','l','I','n','f','o',
/* 0x000f1 = "oiwssigShaWithRsaEncryption" */
    '\x9a','\x92','S','h','a','W','i','t','h','R','s','a','E','n','c','r','y','p','t','i','o','n',
/* 0x00107 = "MsSpcIndirectDataContext" */
    '\x87','\x90','I','n','d','i','r','e','c','t','D','a','t','a','C','o','n','t','e','x','t',
/* 0x0011c = "MsSpcJavaClassDataType1" */
    '\x87','\x90','J','a','v','a','C','l','a','s','s','D','a','t','a','T','y','p','e','1',
/* 0x00130 = "MsEncryptedFileSystem" */
    '\x87','E','n','c','r','y','p','t','e','d','F','i','l','e','S','y','s','t','e','m',
/* 0x00144 = "MsCrossCertDistPoints" */
    '\x87','C','r','o','s','s','C','e','r','t','D','i','s','t','P','o','i','n','t','s',
/* 0x00158 = "MsEnrollCerttypeExtension" */
    '\x87','\xc7','C','e','r','t','t','y','p','e','E','x','t','e','n','s','i','o','n',
/* 0x0016b = "MsSpcCommericalSigning" */
    '\x87','\x90','C','o','m','m','e','r','i','c','a','l','S','i','g','n','i','n','g',
/* 0x0017e = "MsDrmIndividualization" */
    '\x87','\xdc','I','n','d','i','v','i','d','u','a','l','i','z','a','t','i','o','n',
/* 0x00191 = "x500StatOrProvinceName" */
    '\x96','S','t','a','t','O','r','P','r','o','v','i','n','c','e','N','a','m','e',
/* 0x001a4 = "MsCertSrvPreviousCertHash" */
    '\x87','\x99','\xd9','P','r','e','v','i','o','u','s','C','e','r','t','H','a','s','h',
/* 0x001b7 = "MsCaKeyCertIndexPair" */
    '\x87','C','a','K','e','y','C','e','r','t','I','n','d','e','x','P','a','i','r',
/* 0x001ca = "MsAutoEnrollCtlUsage" */
    '\x87','A','u','t','o','E','n','r','o','l','l','C','t','l','U','s','a','g','e',
/* 0x001dd = "idceBasicConstraints" */
    '\x8b','\x95','B','a','s','i','c','C','o','n','s','t','r','a','i','n','t','s',
/* 0x001ef = "pkcs9SMimeCapabilities" */
    '\x85','S','M','i','m','e','C','a','p','a','b','i','l','i','t','i','e','s',
/* 0x00201 = "pkcs7signedAndEnvelopedData" */
    '\x94','\xc4','A','n','d','E','n','v','e','l','o','p','e','d','D','a','t','a',
/* 0x00213 = "pkcs9challengePassword" */
    '\x85','c','h','a','l','l','e','n','g','e','P','a','s','s','w','o','r','d',
/* 0x00225 = "verisignpkiekuIssStrongCrypto" */
    '\x80','\x8c','\xda','I','s','s','S','t','r','o','n','g','C','r','y','p','t','o',
/* 0x00237 = "idkpEmailProtection" */
    '\x8b','\xa1','E','m','a','i','l','P','r','o','t','e','c','t','i','o','n',
/* 0x00248 = "MsCertSrvInfrastructure" */
    '\x87','\x99','\xd9','I','n','f','r','a','s','t','r','u','c','t','u','r','e',
/* 0x00259 = "MsEmbeddedNtCrypto" */
    '\x87','E','m','b','e','d','d','e','d','N','t','C','r','y','p','t','o',
/* 0x0026a = "verisignpkiext-RolloverID" */
    '\x80','\x8c','e','x','t','-','R','o','l','l','o','v','e','r','I','D',
/* 0x0027a = "x500attribute-types" */
    '\x96','a','t','t','r','i','b','u','t','e','-','t','y','p','e','s',
/* 0x0028a = "nisthash-algorithms" */
    '\x9b','h','a','s','h','-','a','l','g','o','r','i','t','h','m','s',
/* 0x0029a = "MsLifetimeSigning" */
    '\x87','L','i','f','e','t','i','m','e','S','i','g','n','i','n','g',
/* 0x002aa = "MsDocumentSigning" */
    '\x87','D','o','c','u','m','e','n','t','S','i','g','n','i','n','g',
/* 0x002ba = "MsRootListSigner" */
    '\x87','R','o','o','t','L','i','s','t','S','i','g','n','e','r',
/* 0x002c9 = "idceissuerAltName" */
    '\x8b','\x95','i','s','s','u','e','r','A','l','t','N','a','m','e',
/* 0x002d8 = "MsSpcLinkType2Aka-CabData" */
    '\x87','\x90','\xd1','\xf7','A','k','a','-','C','a','b','D','a','t','a',
/* 0x002e7 = "pkcs7encryptedData" */
    '\x94','e','n','c','r','y','p','t','e','d','D','a','t','a',
/* 0x002f5 = "pkcs9MessageDigest" */
    '\x85','M','e','s','s','a','g','e','D','i','g','e','s','t',
/* 0x00303 = "MsSpcStatemntType" */
    '\x87','\x90','S','t','a','t','e','m','n','t','T','y','p','e',
/* 0x00311 = "MsTimeStampSigning" */
    '\x87','\xd3','S','t','a','m','p','S','i','g','n','i','n','g',
/* 0x0031f = "netscapeekuserverGatedCrypto" */
    '\x82','\xda','\xc5','G','a','t','e','d','C','r','y','p','t','o',
/* 0x0032d = "MsOemWhqlCrypto" */
    '\x87','O','e','m','W','h','q','l','C','r','y','p','t','o',
/* 0x0033b = "pkcs7envelopedData" */
    '\x94','e','n','v','e','l','o','p','e','d','D','a','t','a',
/* 0x00349 = "MsCertReqExtensions" */
    '\x87','\x99','\xe9','E','x','t','e','n','s','i','o','n','s',
/* 0x00356 = "idceExtKeyUsage" */
    '\x8b','\x95','E','x','t','K','e','y','U','s','a','g','e',
/* 0x00363 = "pkcs9SigningDescription" */
    '\x85','\x84','D','e','s','c','r','i','p','t','i','o','n',
/* 0x00370 = "idkpOCSPSigning" */
    '\x8b','\xa1','O','C','S','P','S','i','g','n','i','n','g',
/* 0x0037d = "MsSpcRawFileData" */
    '\x87','\x90','R','a','w','F','i','l','e','D','a','t','a',
/* 0x0038a = "pkcs7digestedData" */
    '\x94','d','i','g','e','s','t','e','d','D','a','t','a',
/* 0x00397 = "pkcs9EMailAddress" */
    '\x85','E','M','a','i','l','A','d','d','r','e','s','s',
/* 0x003a4 = "x500LocalityName" */
    '\x96','L','o','c','a','l','i','t','y','N','a','m','e',
/* 0x003b1 = "MsCrlNextPublish" */
    '\x87','\xb5','N','e','x','t','P','u','b','l','i','s','h',
/* 0x003be = "netscapeHomePage-url" */
    '\x82','H','o','m','e','P','a','g','e','-','u','r','l',
/* 0x003cb = "idkpClientAuth" */
    '\x8b','\xa1','C','l','i','e','n','t','A','u','t','h',
/* 0x003d7 = "MsSpcAgencyInfo" */
    '\x87','\x90','A','g','e','n','c','y','I','n','f','o',
/* 0x003e3 = "timestamping" */
    't','i','m','e','s','t','a','m','p','i','n','g',
/* 0x003ef = "Timestamping" */
    'T','i','m','e','s','t','a','m','p','i','n','g',
/* 0x003fb = "pkcs9ContentType" */
    '\x85','C','o','n','t','e','n','t','T','y','p','e',
/* 0x00407 = "idkpIPSecEndSystem" */
    '\x8b','\xa1','\xad','E','n','d','S','y','s','t','e','m',
/* 0x00413 = "idkpServerAuth" */
    '\x8b','\xa1','S','e','r','v','e','r','A','u','t','h',
/* 0x0041f = "verisignpkiextensions" */
    '\x80','\x8c','e','x','t','e','n','s','i','o','n','s',
/* 0x0042b = "Organization" */
    'O','r','g','a','n','i','z','a','t','i','o','n',
/* 0x00437 = "authenticode" */
    'a','u','t','h','e','n','t','i','c','o','d','e',
/* 0x00443 = "idcecpanyPolicy" */
    '\x8b','\x95','\xb2','a','n','y','P','o','l','i','c','y',
/* 0x0044f = "x500CountryName" */
    '\x96','C','o','u','n','t','r','y','N','a','m','e',
/* 0x0045b = "Distribution" */
    'D','i','s','t','r','i','b','u','t','i','o','n',
/* 0x00467 = "Unstructured" */
    'U','n','s','t','r','u','c','t','u','r','e','d',
/* 0x00473 = "MsDummySigner" */
    '\x87','D','u','m','m','y','S','i','g','n','e','r',
/* 0x0047f = "usacomputersecurityregister" */
    '\xae','\xfc','\x9f','r','e','g','i','s','t','e','r',
/* 0x0048a = "verisignpkipolicyvtncpclass2" */
    '\x80','\x8c','\x83','\xa6','\xb2','c','l','a','s','s','2',
/* 0x00495 = "verisignpkipolicyvtncpclass3" */
    '\x80','\x8c','\x83','\xa6','\xb2','c','l','a','s','s','3',
/* 0x004a0 = "verisignpkipolicyvtncpclass4" */
    '\x80','\x8c','\x83','\xa6','\xb2','c','l','a','s','s','4',
/* 0x004ab = "idqtACUNotice" */
    '\x8b','\xcb','A','C','U','N','o','t','i','c','e',
/* 0x004b6 = "pkcs9CounterSignature" */
    '\x85','\xb4','S','i','g','n','a','t','u','r','e',
/* 0x004c1 = "verisignpkipolicyvtncpclass1" */
    '\x80','\x8c','\x83','\xa6','\xb2','c','l','a','s','s','1',
/* 0x004cc = "netscapeEntityLogo" */
    '\x82','E','n','t','i','t','y','L','o','g','o',
/* 0x004d7 = "x500CommonName" */
    '\x96','C','o','m','m','o','n','N','a','m','e',
/* 0x004e2 = "securityMechanisms" */
    '\x9f','M','e','c','h','a','n','i','s','m','s',
/* 0x004ed = "MsSpcOpusInfo" */
    '\x87','\x90','O','p','u','s','I','n','f','o',
/* 0x004f7 = "revocation" */
    'r','e','v','o','c','a','t','i','o','n',
/* 0x00501 = "jointiso/itu-t" */
    '\xfa','i','s','o','/','i','t','u','-','t',
/* 0x0050b = "usagoverment" */
    '\xae','g','o','v','e','r','m','e','n','t',
/* 0x00515 = "by-country" */
    'b','y','-','c','o','u','n','t','r','y',
/* 0x0051f = "Identifier" */
    'I','d','e','n','t','i','f','i','e','r',
/* 0x00529 = "MsNt5Crypto" */
    '\x87','N','t','5','C','r','y','p','t','o',
/* 0x00533 = "verisignpkipolicies" */
    '\x80','\x8c','p','o','l','i','c','i','e','s',
/* 0x0053d = "microsoft" */
    'm','i','c','r','o','s','o','f','t',
/* 0x00546 = "dodInternet" */
    '\xd8','I','n','t','e','r','n','e','t',
/* 0x0054f = "netscapebase-url" */
    '\x82','b','a','s','e','-','u','r','l',
/* 0x00558 = "Authority" */
    'A','u','t','h','o','r','i','t','y',
/* 0x00561 = "verisignpkipolicythawtecps-1" */
    '\x80','\x8c','\x83','\xc6','c','p','s','-','1',
/* 0x0056a = "netscapeUserPicture" */
    '\x82','\xd4','P','i','c','t','u','r','e',
/* 0x00573 = "Untrusted" */
    'U','n','t','r','u','s','t','e','d',
/* 0x0057c = "idqtTextNotice" */
    '\x8b','\xcb','\xeb','N','o','t','i','c','e',
/* 0x00585 = "pkixAuthorityInfoAccess" */
    '\xd2','\x9d','\xa0','A','c','c','e','s','s',
/* 0x0058e = "pkcs9ExtensionRequest" */
    '\x85','\xaa','R','e','q','u','e','s','t',
/* 0x00597 = "computer" */
    'c','o','m','p','u','t','e','r',
/* 0x0059f = "security" */
    's','e','c','u','r','i','t','y',
/* 0x005a7 = "verisign" */
    'v','e','r','i','s','i','g','n',
/* 0x005af = "netscapecomment" */
    '\x82','c','o','m','m','e','n','t',
/* 0x005b7 = "Policies" */
    'P','o','l','i','c','i','e','s',
/* 0x005bf = "Recovery" */
    'R','e','c','o','v','e','r','y',
/* 0x005c7 = "netscape" */
    'n','e','t','s','c','a','p','e',
/* 0x005cf = "Template" */
    'T','e','m','p','l','a','t','e',
/* 0x005d7 = "MsSpcPeImagePageHashesV1" */
    '\x87','\x90','\xd6','\xab','\xb6','\xc2','\xe3',
/* 0x005de = "MsCrlVirtualBase" */
    '\x87','\xb5','\xe5','B','a','s','e',
/* 0x005e5 = "Subject" */
    'S','u','b','j','e','c','t',
/* 0x005ec = "Virtual" */
    'V','i','r','t','u','a','l',
/* 0x005f3 = "company" */
    'c','o','m','p','a','n','y',
/* 0x005fa = "EAPOver" */
    'E','A','P','O','v','e','r',
/* 0X00601 = "renewal" */
    'e','n','e','w','a','l',
/* 0x00607 = "Counter" */
    'C','o','u','n','t','e','r',
/* 0x0060e = "netscapesslservername" */
    '\x82','\xe2','\xc5','n','a','m','e',
/* 0x00615 = "MsSpcPeImagePageHashesV2" */
    '\x87','\x90','\xd6','\xab','\xb6','\xc2','\xe4',
/* 0x0061c = "oiwssigSha1WithRsaEncryption" */
    '\x9a','\x92','\xb1','\x88','\x8e','\x81',
/* 0x00622 = "idceAuthorityKeyIdentifierDeprecated" */
    '\x8b','\x95','\x9d','\x97','\x9c','\x86',
/* 0x00628 = "Sha384" */
    'S','h','a','3','8','4',
/* 0x0062e = "idceSubjectAltNameDeprecated" */
    '\x8b','\x95','\xa2','\xb9','\x8d','\x86',
/* 0x00634 = "oiwssigMd5WithRsaEncryption" */
    '\x9a','\x92','\xc9','\x88','\x8e','\x81',
/* 0x0063a = "oiwssigMd2WithRsaEncryption" */
    '\x9a','\x92','\xdb','\x88','\x8e','\x81',
/* 0x00640 = "thawte" */
    't','h','a','w','t','e',
/* 0x00646 = "Hashes" */
    'H','a','s','h','e','s',
/* 0X0064c = "signed" */
    'i','g','n','e','d',
/* 0x00651 = "idqtACPS" */
    '\x8b','\xcb','A','C','P','S',
/* 0x00657 = "server" */
    's','e','r','v','e','r',
/* 0x0065d = "policy" */
    'p','o','l','i','c','y',
/* 0x00663 = "idkpEAPOverLAN" */
    '\x8b','\xa1','\xba','L','A','N',
/* 0x00669 = "Tunnel" */
    'T','u','n','n','e','l',
/* 0x0066f = "idkpDVCS" */
    '\x8b','\xa1','D','V','C','S',
/* 0X00675 = "Sha512" */
    'h','a','5','1','2',
/* 0x0067a = "Sha224" */
    'S','h','a','2','2','4',
/* 0x00680 = "idkpEAPOverPPP" */
    '\x8b','\xa1','\xba','P','P','P',
/* 0x00686 = "Sha256" */
    'S','h','a','2','5','6',
/* 0x0068c = "verisignpkipolicyvtncp6" */
    '\x80','\x8c','\x83','\xa6','\xb2','6',
/* 0x00692 = "Issuer" */
    'I','s','s','u','e','r',
/* 0x00698 = "oiwssigMd4WithRsaEncryption" */
    '\x9a','\x92','\xca','\x88','\x8e','\x81',
/* 0x0069e = "idceIssuerAltNameDeprecated" */
    '\x8b','\x95','\xbd','\xb9','\x8d','\x86',
/* 0x006a4 = "MsCounterSign" */
    '\x87','\xb4','S','i','g','n',
/* 0x006aa = "rsadsi" */
    'r','s','a','d','s','i',
/* 0x006b0 = "Type3" */
    'T','y','p','e','3',
/* 0x006b5 = "idceSubjectKeyIdentifier" */
    '\x8b','\x95','\xa2','\x97','\x9c',
/* 0x006ba = "Image" */
    'I','m','a','g','e',
/* 0x006bf = "Type2" */
    'T','y','p','e','2',
/* 0x006c4 = "idceKeyAttributesDeprecated" */
    '\x8b','\x95','\x97','\xa9','\x86',
/* 0x006c9 = "pkcs7" */
    'p','k','c','s','7',
/* 0x006ce = "pkcs1" */
    'p','k','c','s','1',
/* 0x006d3 = "pkcs1Md2WithRsaEncryption" */
    '\x8a','\xdb','\x88','\x8e','\x81',
/* 0x006d8 = "usacompanyarc" */
    '\xae','\xfb','a','r','c',
/* 0x006dd = "verisignpkipolicycistype2" */
    '\x80','\x8c','\x83','\xc8','\xf0',
/* 0x006e2 = "MsCertTrustListSigning" */
    '\x87','\x99','\xed','\xd0','\x84',
/* 0x006e7 = "IPSec" */
    'I','P','S','e','c',
/* 0x006ec = "pkcs1Sha512WithRsaEncryption" */
    '\x8a','\xbb','\x88','\x8e','\x81',
/* 0x006f1 = "pkcs1Sha384WithRsaEncryption" */
    '\x8a','\xbe','\x88','\x8e','\x81',
/* 0x006f6 = "pkcs1RsaPss" */
    '\x8a','\x8e','P','s','s',
/* 0x006fb = "pkcs1Md4WithRsaEncryption" */
    '\x8a','\xca','\x88','\x8e','\x81',
/* 0x00700 = "pkcs1Md5WithRsaEncryption" */
    '\x8a','\xc9','\x88','\x8e','\x81',
/* 0x00705 = "Trust" */
    'T','r','u','s','t',
/* 0x0070a = "pkcs1Sha1WithRsaEncryption" */
    '\x8a','\xb1','\x88','\x8e','\x81',
/* 0x0070f = "asn.1" */
    'a','s','n','.','1',
/* 0x00714 = "type2" */
    't','y','p','e','2',
/* 0x00719 = "Ms??2.1" */
    '\x87','\xde','2','.','1',
/* 0x0071e = "pkcs7data" */
    '\x94','d','a','t','a',
/* 0x00723 = "idceCertificatePoliciesDeprecated" */
    '\x8b','\x95','\x89','\xaf','\x86',
/* 0x00728 = "MsSpcPeImageData" */
    '\x87','\x90','\xd6','\xab','\x8f',
/* 0x0072d = "type1" */
    't','y','p','e','1',
/* 0x00732 = "pkcs1Sha224WithRsaEncryption" */
    '\x8a','\xc1','\x88','\x8e','\x81',
/* 0x00737 = "idqtCPS" */
    '\x8b','\xcb','C','P','S',
/* 0x0073c = "idceCrlDistributionPoints" */
    '\x8b','\x95','\xb5','\xa4','\xa5',
/* 0x00741 = "pkcs1Sha256WithRsaEncryption" */
    '\x8a','\xc0','\x88','\x8e','\x81',
/* 0x00746 = "joint" */
    'j','o','i','n','t',
/* 0x0074b = "verisignpkipolicy21" */
    '\x80','\x8c','\x83','2','1',
/* 0x00750 = "verisignpkipolicycistype1" */
    '\x80','\x8c','\x83','\xc8','\xe8',
/* 0x00755 = "Ms??3.2" */
    '\x87','\xde','3','.','2',
/* 0x0075a = "pkcs9" */
    'p','k','c','s','9',
/* 0x0075f = "netscapecertrenewalurl" */
    '\x82','\xcc','\xe6','\xa7',
/* 0x00763 = "idceNameConstraints" */
    '\x8b','\x95','\x8d','\x98',
/* 0x00767 = "Link" */
    'L','i','n','k',
/* 0x0076b = "netscapecapolicyurl" */
    '\x82','\xdd','\x83','\xa7',
/* 0x0076f = "Unit" */
    'U','n','i','t',
/* 0x00773 = "ssig" */
    's','s','i','g',
/* 0x00777 = "verisignpkipolicy9" */
    '\x80','\x8c','\x83','9',
/* 0x0077b = "MsSpcLinkType3" */
    '\x87','\x90','\xd1','\xf8',
/* 0x0077f = "x500OrganizationUnitName" */
    '\x96','\xa3','\xf1','\x8d',
/* 0x00783 = "nist" */
    'n','i','s','t',
/* 0x00787 = "netscapecarevocationurl" */
    '\x82','\xdd','\xa8','\xa7',
/* 0x0078b = "Sha1" */
    'S','h','a','1',
/* 0x0078f = "pkix" */
    'p','k','i','x',
/* 0x00793 = "cert" */
    'c','e','r','t',
/* 0x00797 = "idkpIPSecTunnel" */
    '\x8b','\xa1','\xad','\xee',
/* 0x0079b = "idkpCodeSigning" */
    '\x8b','\xa1','\xd5','\x84',
/* 0x0079f = "User" */
    'U','s','e','r',
/* 0x007a3 = "x500" */
    'x','5','0','0',
/* 0x007a7 = "idkpIPSecUser" */
    '\x8b','\xa1','\xad','\xd4',
/* 0x007ab = "Text" */
    'T','e','x','t',
/* 0x007af = "idcePolicyConstraints" */
    '\x8b','\x95','\xbf','\x98',
/* 0x007b3 = "idceCertificateIssuer" */
    '\x8b','\x95','\x89','\xbd',
/* 0x007b7 = "pkixLogoType" */
    '\xd2','\xce','\xb8',
/* 0x007ba = "idqtUNotice" */
    '\x8b','\xcb','\xf9',
/* 0x007bd = "MsWhqlCrypto" */
    '\x87','\xcf','\x93',
/* 0x007c0 = "MsKeyRecovery" */
    '\x87','\x97','\xb0',
/* 0x007c3 = "nistaesalgorithms" */
    '\x9b','\xe7','\x91',
/* 0x007c6 = "vtn" */
    'v','t','n',
/* 0x007c9 = "pkcs7signedData" */
    '\x94','\xc4','\x8f',
/* 0x007cc = "netscaperevocationurl" */
    '\x82','\xa8','\xa7',
/* 0x007cf = "Md5" */
    'M','d','5',
/* 0x007d2 = "Srv" */
    'S','r','v',
/* 0x007d5 = "spc" */
    's','p','c',
/* 0x007d8 = "dod" */
    'd','o','d',
/* 0x007db = "Md2" */
    'M','d','2',
/* 0x007de = "pkcs9SigningTime" */
    '\x85','\x84','\xd3',
/* 0x007e1 = "Spc" */
    'S','p','c',
/* 0X007e4 = "cis" */
    'i','s',
/* 0x007e6 = "eku" */
    'e','k','u',
/* 0x007e9 = "ssl" */
    's','s','l',
/* 0x007ec = "netscapecerttype" */
    '\x82','\xcc','\xf2',
/* 0x007ef = "MsCertificateTemplate" */
    '\x87','\x89','\xea',
/* 0x007f2 = "Crl" */
    'C','r','l',
/* 0x007f5 = "x500OrganizationName" */
    '\x96','\xa3','\x8d',
/* 0x007f8 = "Md4" */
    'M','d','4',
/* 0x007fb = "pkcs1RsaEncryption" */
    '\x8a','\x8e','\x81',
/* 0x007fe = "idkpTimestamping" */
    '\x8b','\xa1','\xec',
/* 0x00801 = "oiwssigalgorithms" */
    '\x9a','\x92','\x91',
/* 0x00804 = "pkcs9UntrustedName" */
    '\x85','\xe1','\x8d',
/* 0x00807 = "usa" */
    'u','s','a',
/* 0x0080a = "oiw" */
    'o','i','w',
/* 0x0080d = "aes" */
    'a','e','s',
/* 0x00810 = "Drm" */
    'D','r','m',
/* 0x00813 = "pkcs9UnstructuredAddress" */
    '\x85','\xe0','\xb3',
/* 0x00816 = "msauthenticode" */
    '\xd7','\xf5',
/* 0x00818 = "V2" */
    'V','2',
/* 0x0081a = "qt" */
    'q','t',
/* 0x0081c = "??" */
    '?','?',
/* 0x0081e = "kp" */
    'k','p',
/* 0x00820 = "V1" */
    'V','1',
/* 0x00822 = "mstimestamping" */
    '\xd7','\xf4',
/* 0x00824 = "nistSha224" */
    '\x9b','\xc1',
/* 0x00826 = "nistSha256" */
    '\x9b','\xc0',
/* 0x00828 = "nistSha512" */
    '\x9b','\xbb',
/* 0x0082a = "nistSha384" */
    '\x9b','\xbe',
/* 0x0082c = "msspc" */
    '\xd7','\xf6',
/* 0x0082e = "Ms" */
    'M','s',
/* 0x00830 = "nistalgorithms" */
    '\x9b','\x91',
/* 0x00832 = "rsadsi" */
    '\xdf',
/* 0x00833 = "microsoft" */
    '\xfe',
};
AssertCompile(sizeof(g_achStrTabOidDbStrTab) == 0x834);

static const RTBLDPROGSTRREF g_aCompDictOidDbStrTab[127] = 
{
    { 0x0005a7, 0x08 }, // verisign
    { 0x0000fd, 0x0a }, // Encryption
    { 0x0005c7, 0x08 }, // netscape
    { 0x00065d, 0x06 }, // policy
    { 0x0000d4, 0x07 }, // Signing
    { 0x00075a, 0x05 }, // pkcs9
    { 0x00002e, 0x0a }, // Deprecated
    { 0x00082e, 0x02 }, // Ms
    { 0x0000f6, 0x04 }, // With
    { 0x000009, 0x0b }, // Certificate
    { 0x0006ce, 0x05 }, // pkcs1
    { 0x0000cb, 0x02 }, // id
    { 0x00078f, 0x03 }, // pki
    { 0x0001a0, 0x04 }, // Name
    { 0x0000fa, 0x03 }, // Rsa
    { 0x00007b, 0x04 }, // Data
    { 0x0007e1, 0x03 }, // Spc
    { 0x000290, 0x0a }, // algorithms
    { 0x000773, 0x04 }, // ssig
    { 0x000231, 0x06 }, // Crypto
    { 0x0006c9, 0x05 }, // pkcs7
    { 0x0000a7, 0x02 }, // ce
    { 0x0007a3, 0x04 }, // x500
    { 0x0000b6, 0x03 }, // Key
    { 0x0001e4, 0x0b }, // Constraints
    { 0x000009, 0x04 }, // Cert
    { 0x00080a, 0x03 }, // oiw
    { 0x000783, 0x04 }, // nist
    { 0x00051f, 0x0a }, // Identifier
    { 0x000558, 0x09 }, // Authority
    { 0x0000b9, 0x05 }, // Usage
    { 0x00059f, 0x08 }, // security
    { 0x000092, 0x04 }, // Info
    { 0x00081e, 0x02 }, // kp
    { 0x0005e5, 0x07 }, // Subject
    { 0x00042b, 0x0c }, // Organization
    { 0x00045b, 0x0c }, // Distribution
    { 0x000152, 0x06 }, // Points
    { 0x0007c6, 0x03 }, // vtn
    { 0x0003c8, 0x03 }, // url
    { 0x0004f7, 0x0a }, // revocation
    { 0x000014, 0x0a }, // Attributes
    { 0x000162, 0x09 }, // Extension
    { 0x0006ba, 0x05 }, // Image
    { 0x000089, 0x09 }, // Criterial
    { 0x0006e7, 0x05 }, // IPSec
    { 0x000807, 0x03 }, // usa
    { 0x0005b7, 0x08 }, // Policies
    { 0x0005bf, 0x08 }, // Recovery
    { 0x00078b, 0x04 }, // Sha1
    { 0x000565, 0x02 }, // cp
    { 0x00039d, 0x07 }, // Address
    { 0x000607, 0x07 }, // Counter
    { 0x0007f2, 0x03 }, // Crl
    { 0x0003c3, 0x04 }, // Page
    { 0x0000a9, 0x04 }, // Auth
    { 0x00012b, 0x04 }, // Type
    { 0x0002d1, 0x03 }, // Alt
    { 0x0005fa, 0x07 }, // EAPOver
    { 0x000674, 0x06 }, // Sha512
    { 0x0002c3, 0x06 }, // Signer
    { 0x000692, 0x06 }, // Issuer
    { 0x000628, 0x06 }, // Sha384
    { 0x000449, 0x06 }, // Policy
    { 0x000686, 0x06 }, // Sha256
    { 0x00067a, 0x06 }, // Sha224
    { 0x000646, 0x06 }, // Hashes
    { 0x00013e, 0x06 }, // System
    { 0x00064b, 0x06 }, // signed
    { 0x000657, 0x06 }, // server
    { 0x000640, 0x06 }, // thawte
    { 0x0001cf, 0x06 }, // Enroll
    { 0x0007e3, 0x03 }, // cis
    { 0x0007cf, 0x03 }, // Md5
    { 0x0007f8, 0x03 }, // Md4
    { 0x00081a, 0x02 }, // qt
    { 0x000793, 0x04 }, // cert
    { 0x00013a, 0x04 }, // File
    { 0x0004d3, 0x04 }, // Logo
    { 0x000331, 0x04 }, // Whql
    { 0x0002bf, 0x04 }, // List
    { 0x000767, 0x04 }, // Link
    { 0x00078f, 0x04 }, // pkix
    { 0x0003ef, 0x04 }, // Time
    { 0x00079f, 0x04 }, // User
    { 0x0000d0, 0x04 }, // Code
    { 0x0000be, 0x02 }, // Pe
    { 0x000298, 0x02 }, // ms
    { 0x0007d8, 0x03 }, // dod
    { 0x0007d2, 0x03 }, // Srv
    { 0x0007e6, 0x03 }, // eku
    { 0x0007db, 0x03 }, // Md2
    { 0x000810, 0x03 }, // Drm
    { 0x000010, 0x02 }, // ca
    { 0x00081c, 0x02 }, // ??
    { 0x0006aa, 0x06 }, // rsadsi
    { 0x000467, 0x0c }, // Unstructured
    { 0x000573, 0x09 }, // Untrusted
    { 0x0007e9, 0x03 }, // ssl
    { 0x000820, 0x02 }, // V1
    { 0x000818, 0x02 }, // V2
    { 0x0005ec, 0x07 }, // Virtual
    { 0x000600, 0x07 }, // renewal
    { 0x00080d, 0x03 }, // aes
    { 0x00072d, 0x05 }, // type1
    { 0x000590, 0x03 }, // Req
    { 0x0005cf, 0x08 }, // Template
    { 0x0007ab, 0x04 }, // Text
    { 0x0003ef, 0x0c }, // Timestamping
    { 0x000705, 0x05 }, // Trust
    { 0x000669, 0x06 }, // Tunnel
    { 0x000285, 0x05 }, // types
    { 0x000714, 0x05 }, // type2
    { 0x00076f, 0x04 }, // Unit
    { 0x00015e, 0x04 }, // type
    { 0x00012b, 0x05 }, // Type1
    { 0x0003e3, 0x0c }, // timestamping
    { 0x000437, 0x0c }, // authenticode
    { 0x0007d5, 0x03 }, // spc
    { 0x0006bf, 0x05 }, // Type2
    { 0x0006b0, 0x05 }, // Type3
    { 0x0004af, 0x07 }, // UNotice
    { 0x000746, 0x05 }, // joint
    { 0x0005f3, 0x07 }, // company
    { 0x000597, 0x08 }, // computer
    { 0x000518, 0x07 }, // country
    { 0x00053d, 0x09 }, // microsoft
};

static const RTBLDPROGSTRTAB g_OidDbStrTab = 
{
    /*.pchStrTab  = */ &g_achStrTabOidDbStrTab[0],
    /*.cchStrTab  = */ sizeof(g_achStrTabOidDbStrTab),
    /*.cCompDict  = */ 127,
    /*.paCompDict = */ &g_aCompDictOidDbStrTab[0]
};

#if defined(RT_ARCH_AMD64) || defined(RT_ARCH_X86)
# pragma pack(2)
#endif
typedef struct RTOIDENTRYSMALL
{
    uint32_t    uKey        : 6;
    uint32_t    cchString   : 6;
    uint32_t    fBigTable   : 1;
    uint32_t    cChildren   : 7;
    uint32_t    idxChildren : 12;
    uint16_t    offString;
} RTOIDENTRYSMALL;
#if defined(RT_ARCH_AMD64) || defined(RT_ARCH_X86)
# pragma pack()
AssertCompileSize(RTOIDENTRYSMALL, 6);
#endif
typedef RTOIDENTRYSMALL const *PCRTOIDENTRYSMALL;

static const RTOIDENTRYSMALL g_aSmallOidTable[] = 
{
    {  1,  0, 0,  2,    2,     0 }, /* 0.1 */
    {  2, 10, 0,  3,  132,  1281 }, /* 0.2 = "jointiso/itu-t" */
    {  2,  0, 1,  1,    0,     0 }, /* 0.1.2 */
    {  3,  0, 0,  2,   36,     0 }, /* 0.1.3 */
    {  1,  4, 0,  3,    5,  1737 }, /* 0.1.2.840.113549.1 = "pkcs" */
    {  1,  1, 0, 10,    8,  1747 }, /* 0.1.2.840.113549.1.1 = "pkcs1" */
    {  7,  1, 0,  6,   18,   513 }, /* 0.1.2.840.113549.1.7 = "pkcs7" */
    {  9,  1, 0, 12,   24,     0 }, /* 0.1.2.840.113549.1.9 = "pkcs9" */
    {  1,  3, 0,  0,    0,  2043 }, /* 0.1.2.840.113549.1.1.1 = "pkcs1RsaEncryption" */
    {  2,  5, 0,  0,    0,  1747 }, /* 0.1.2.840.113549.1.1.2 = "pkcs1Md2WithRsaEncryption" */
    {  3,  5, 0,  0,    0,  1787 }, /* 0.1.2.840.113549.1.1.3 = "pkcs1Md4WithRsaEncryption" */
    {  4,  5, 0,  0,    0,  1792 }, /* 0.1.2.840.113549.1.1.4 = "pkcs1Md5WithRsaEncryption" */
    {  5,  5, 0,  0,    0,  1802 }, /* 0.1.2.840.113549.1.1.5 = "pkcs1Sha1WithRsaEncryption" */
    { 10,  5, 0,  0,    0,  1782 }, /* 0.1.2.840.113549.1.1.10 = "pkcs1RsaPss" */
    { 11,  5, 0,  0,    0,  1857 }, /* 0.1.2.840.113549.1.1.11 = "pkcs1Sha256WithRsaEncryption" */
    { 12,  5, 0,  0,    0,  1777 }, /* 0.1.2.840.113549.1.1.12 = "pkcs1Sha384WithRsaEncryption" */
    { 13,  5, 0,  0,    0,  1772 }, /* 0.1.2.840.113549.1.1.13 = "pkcs1Sha512WithRsaEncryption" */
    { 14,  5, 0,  0,    0,  1842 }, /* 0.1.2.840.113549.1.1.14 = "pkcs1Sha224WithRsaEncryption" */
    {  1,  5, 0,  0,    0,  1822 }, /* 0.1.2.840.113549.1.7.1 = "pkcs7data" */
    {  2,  3, 0,  0,    0,  1993 }, /* 0.1.2.840.113549.1.7.2 = "pkcs7signedData" */
    {  3, 14, 0,  0,    0,   827 }, /* 0.1.2.840.113549.1.7.3 = "pkcs7envelopedData" */
    {  4, 18, 0,  0,    0,   513 }, /* 0.1.2.840.113549.1.7.4 = "pkcs7signedAndEnvelopedData" */
    {  5, 13, 0,  0,    0,   906 }, /* 0.1.2.840.113549.1.7.5 = "pkcs7digestedData" */
    {  6, 14, 0,  0,    0,   743 }, /* 0.1.2.840.113549.1.7.6 = "pkcs7encryptedData" */
    {  1, 13, 0,  0,    0,   919 }, /* 0.1.2.840.113549.1.9.1 = "pkcs9EMailAddress" */
    {  2,  3, 0,  0,    0,  2052 }, /* 0.1.2.840.113549.1.9.2 = "pkcs9UntrustedName" */
    {  3, 12, 0,  0,    0,  1019 }, /* 0.1.2.840.113549.1.9.3 = "pkcs9ContentType" */
    {  4, 14, 0,  0,    0,   757 }, /* 0.1.2.840.113549.1.9.4 = "pkcs9MessageDigest" */
    {  5,  3, 0,  0,    0,  2014 }, /* 0.1.2.840.113549.1.9.5 = "pkcs9SigningTime" */
    {  6, 11, 0,  0,    0,  1206 }, /* 0.1.2.840.113549.1.9.6 = "pkcs9CounterSignature" */
    {  7, 18, 0,  0,    0,   531 }, /* 0.1.2.840.113549.1.9.7 = "pkcs9challengePassword" */
    {  8,  3, 0,  0,    0,  2067 }, /* 0.1.2.840.113549.1.9.8 = "pkcs9UnstructuredAddress" */
    {  9, 30, 0,  0,    0,     0 }, /* 0.1.2.840.113549.1.9.9 = "pkcs9ExtendedCertificateAttributes" */
    { 13, 13, 0,  0,    0,   867 }, /* 0.1.2.840.113549.1.9.13 = "pkcs9SigningDescription" */
    { 14,  9, 0,  0,    0,  1422 }, /* 0.1.2.840.113549.1.9.14 = "pkcs9ExtensionRequest" */
    { 15, 18, 0,  0,    0,   495 }, /* 0.1.2.840.113549.1.9.15 = "pkcs9SMimeCapabilities" */
    {  6,  1, 0,  1,   38,  1350 }, /* 0.1.3.6 = "dod" */
    { 14,  0, 0,  1,  122,     0 }, /* 0.1.3.14 */
    {  1,  9, 0,  2,   39,  1350 }, /* 0.1.3.6.1 = "dodInternet" */
    {  4,  0, 0,  1,   41,     0 }, /* 0.1.3.6.1.4 */
    {  5,  1, 0,  1,   97,  1153 }, /* 0.1.3.6.1.5 = "security" */
    {  1,  0, 1,  1,    2,     0 }, /* 0.1.3.6.1.4.1 */
    {  2,  2, 0,  2,   47,  2070 }, /* 0.1.3.6.1.4.1.311.2 = "msauthenticode" */
    {  3,  2, 0,  1,   67,  2082 }, /* 0.1.3.6.1.4.1.311.3 = "mstimestamping" */
    { 10,  0, 0,  3,   70,     0 }, /* 0.1.3.6.1.4.1.311.10 */
    { 20,  0, 0,  2,   88,     0 }, /* 0.1.3.6.1.4.1.311.20 */
    { 21, 17, 0,  7,   90,   584 }, /* 0.1.3.6.1.4.1.311.21 = "MsCertSrvInfrastructure" */
    {  1,  2, 0, 16,   49,  2092 }, /* 0.1.3.6.1.4.1.311.2.1 = "msspc" */
    {  3,  0, 0,  2,   65,     0 }, /* 0.1.3.6.1.4.1.311.2.3 */
    {  1,  5, 0,  0,    0,  1817 }, /* 0.1.3.6.1.4.1.311.2.1.1 = "Ms??2.1" */
    {  4, 21, 0,  0,    0,   263 }, /* 0.1.3.6.1.4.1.311.2.1.4 = "MsSpcIndirectDataContext" */
    { 10, 12, 0,  0,    0,   983 }, /* 0.1.3.6.1.4.1.311.2.1.10 = "MsSpcAgencyInfo" */
    { 11, 14, 0,  0,    0,   771 }, /* 0.1.3.6.1.4.1.311.2.1.11 = "MsSpcStatemntType" */
    { 12, 10, 0,  0,    0,  1261 }, /* 0.1.3.6.1.4.1.311.2.1.12 = "MsSpcOpusInfo" */
    { 14, 13, 0,  0,    0,   841 }, /* 0.1.3.6.1.4.1.311.2.1.14 = "MsCertReqExtensions" */
    { 15,  5, 0,  0,    0,  1832 }, /* 0.1.3.6.1.4.1.311.2.1.15 = "MsSpcPeImageData" */
    { 18, 13, 0,  0,    0,   893 }, /* 0.1.3.6.1.4.1.311.2.1.18 = "MsSpcRawFileData" */
    { 19, 23, 0,  0,    0,   104 }, /* 0.1.3.6.1.4.1.311.2.1.19 = "MsSpcStructuredStorageData" */
    { 20, 20, 0,  0,    0,   284 }, /* 0.1.3.6.1.4.1.311.2.1.20 = "MsSpcJavaClassDataType1" */
    { 21, 23, 0,  0,    0,   196 }, /* 0.1.3.6.1.4.1.311.2.1.21 = "MsSpcIndividualCodeSigning" */
    { 22, 19, 0,  0,    0,   363 }, /* 0.1.3.6.1.4.1.311.2.1.22 = "MsSpcCommericalSigning" */
    { 25, 15, 0,  0,    0,   728 }, /* 0.1.3.6.1.4.1.311.2.1.25 = "MsSpcLinkType2Aka-CabData" */
    { 26, 22, 0,  0,    0,   219 }, /* 0.1.3.6.1.4.1.311.2.1.26 = "MsSpcMinimalCriterialInfo" */
    { 27, 23, 0,  0,    0,   127 }, /* 0.1.3.6.1.4.1.311.2.1.27 = "MsSpcFinacialCriterialInfo" */
    { 28,  4, 0,  0,    0,  1915 }, /* 0.1.3.6.1.4.1.311.2.1.28 = "MsSpcLinkType3" */
    {  1,  7, 0,  0,    0,  1495 }, /* 0.1.3.6.1.4.1.311.2.3.1 = "MsSpcPeImagePageHashesV1" */
    {  2,  7, 0,  0,    0,  1557 }, /* 0.1.3.6.1.4.1.311.2.3.2 = "MsSpcPeImagePageHashesV2" */
    {  3,  0, 0,  2,   68,     0 }, /* 0.1.3.6.1.4.1.311.3.3 */
    {  1,  6, 0,  0,    0,  1700 }, /* 0.1.3.6.1.4.1.311.3.3.1 = "MsCounterSign" */
    {  2,  5, 0,  0,    0,  1877 }, /* 0.1.3.6.1.4.1.311.3.3.2 = "Ms??3.2" */
    {  3,  0, 0, 12,   73,     0 }, /* 0.1.3.6.1.4.1.311.10.3 */
    {  5,  0, 0,  2,   85,     0 }, /* 0.1.3.6.1.4.1.311.10.5 */
    {  9,  0, 0,  1,   87,     0 }, /* 0.1.3.6.1.4.1.311.10.9 */
    {  1,  5, 0,  0,    0,  1762 }, /* 0.1.3.6.1.4.1.311.10.3.1 = "MsCertTrustListSigning" */
    {  2, 14, 0,  0,    0,   785 }, /* 0.1.3.6.1.4.1.311.10.3.2 = "MsTimeStampSigning" */
    {  4, 20, 0,  0,    0,   304 }, /* 0.1.3.6.1.4.1.311.10.3.4 = "MsEncryptedFileSystem" */
    {  5,  3, 0,  0,    0,  1981 }, /* 0.1.3.6.1.4.1.311.10.3.5 = "MsWhqlCrypto" */
    {  6, 10, 0,  0,    0,  1321 }, /* 0.1.3.6.1.4.1.311.10.3.6 = "MsNt5Crypto" */
    {  7, 14, 0,  0,    0,   813 }, /* 0.1.3.6.1.4.1.311.10.3.7 = "MsOemWhqlCrypto" */
    {  8, 17, 0,  0,    0,   601 }, /* 0.1.3.6.1.4.1.311.10.3.8 = "MsEmbeddedNtCrypto" */
    {  9, 15, 0,  0,    0,   698 }, /* 0.1.3.6.1.4.1.311.10.3.9 = "MsRootListSigner" */
    { 10, 23, 0,  0,    0,    81 }, /* 0.1.3.6.1.4.1.311.10.3.10 = "MsQualifiedSubordination" */
    { 11,  3, 0,  0,    0,  1984 }, /* 0.1.3.6.1.4.1.311.10.3.11 = "MsKeyRecovery" */
    { 12, 16, 0,  0,    0,   682 }, /* 0.1.3.6.1.4.1.311.10.3.12 = "MsDocumentSigning" */
    { 13, 16, 0,  0,    0,   666 }, /* 0.1.3.6.1.4.1.311.10.3.13 = "MsLifetimeSigning" */
    {  1,  2, 0,  0,    0,   382 }, /* 0.1.3.6.1.4.1.311.10.5.1 = "MsDrm" */
    {  2, 19, 0,  0,    0,   382 }, /* 0.1.3.6.1.4.1.311.10.5.2 = "MsDrmIndividualization" */
    {  1, 20, 0,  0,    0,   324 }, /* 0.1.3.6.1.4.1.311.10.9.1 = "MsCrossCertDistPoints" */
    {  1, 19, 0,  0,    0,   458 }, /* 0.1.3.6.1.4.1.311.20.1 = "MsAutoEnrollCtlUsage" */
    {  2, 19, 0,  0,    0,   344 }, /* 0.1.3.6.1.4.1.311.20.2 = "MsEnrollCerttypeExtension" */
    {  1, 19, 0,  0,    0,   439 }, /* 0.1.3.6.1.4.1.311.21.1 = "MsCaKeyCertIndexPair" */
    {  2, 19, 0,  0,    0,   420 }, /* 0.1.3.6.1.4.1.311.21.2 = "MsCertSrvPreviousCertHash" */
    {  3,  7, 0,  0,    0,  1502 }, /* 0.1.3.6.1.4.1.311.21.3 = "MsCrlVirtualBase" */
    {  4, 13, 0,  0,    0,   945 }, /* 0.1.3.6.1.4.1.311.21.4 = "MsCrlNextPublish" */
    {  6,  3, 0,  0,    0,  1984 }, /* 0.1.3.6.1.4.1.311.21.6 = "MsKeyRecovery" */
    {  7,  3, 0,  0,    0,  2031 }, /* 0.1.3.6.1.4.1.311.21.7 = "MsCertificateTemplate" */
    {  9, 12, 0,  0,    0,  1139 }, /* 0.1.3.6.1.4.1.311.21.9 = "MsDummySigner" */
    {  5, 11, 0,  1,   98,  1250 }, /* 0.1.3.6.1.5.5 = "securityMechanisms" */
    {  7, 25, 0,  3,   99,    56 }, /* 0.1.3.6.1.5.5.7 = "public-key-infrastructure" */
    {  1,  0, 0,  2,  102,     0 }, /* 0.1.3.6.1.5.5.7.1 */
    {  2,  0, 0,  5,  104,     0 }, /* 0.1.3.6.1.5.5.7.2 */
    {  3,  0, 0, 13,  109,     0 }, /* 0.1.3.6.1.5.5.7.3 */
    {  1,  9, 0,  0,    0,  1413 }, /* 0.1.3.6.1.5.5.7.1.1 = "pkixAuthorityInfoAccess" */
    { 12,  3, 0,  0,    0,  1975 }, /* 0.1.3.6.1.5.5.7.1.12 = "pkixLogoType" */
    {  1,  5, 0,  0,    0,  1847 }, /* 0.1.3.6.1.5.5.7.2.1 = "idqtCPS" */
    {  2,  3, 0,  0,    0,  1978 }, /* 0.1.3.6.1.5.5.7.2.2 = "idqtUNotice" */
    {  3,  9, 0,  0,    0,  1404 }, /* 0.1.3.6.1.5.5.7.2.3 = "idqtTextNotice" */
    {  4,  6, 0,  0,    0,  1617 }, /* 0.1.3.6.1.5.5.7.2.4 = "idqtACPS" */
    {  5, 11, 0,  0,    0,  1195 }, /* 0.1.3.6.1.5.5.7.2.5 = "idqtACUNotice" */
    {  1, 12, 0,  0,    0,  1043 }, /* 0.1.3.6.1.5.5.7.3.1 = "idkpServerAuth" */
    {  2, 12, 0,  0,    0,   971 }, /* 0.1.3.6.1.5.5.7.3.2 = "idkpClientAuth" */
    {  3,  4, 0,  0,    0,  1947 }, /* 0.1.3.6.1.5.5.7.3.3 = "idkpCodeSigning" */
    {  4, 17, 0,  0,    0,   567 }, /* 0.1.3.6.1.5.5.7.3.4 = "idkpEmailProtection" */
    {  5, 12, 0,  0,    0,  1031 }, /* 0.1.3.6.1.5.5.7.3.5 = "idkpIPSecEndSystem" */
    {  6,  4, 0,  0,    0,  1943 }, /* 0.1.3.6.1.5.5.7.3.6 = "idkpIPSecTunnel" */
    {  7,  4, 0,  0,    0,  1959 }, /* 0.1.3.6.1.5.5.7.3.7 = "idkpIPSecUser" */
    {  8,  3, 0,  0,    0,  2046 }, /* 0.1.3.6.1.5.5.7.3.8 = "idkpTimestamping" */
    {  9, 13, 0,  0,    0,   880 }, /* 0.1.3.6.1.5.5.7.3.9 = "idkpOCSPSigning" */
    { 10,  6, 0,  0,    0,  1647 }, /* 0.1.3.6.1.5.5.7.3.10 = "idkpDVCS" */
    { 11, 23, 0,  0,    0,   150 }, /* 0.1.3.6.1.5.5.7.3.11 = "idkpSBGPCertAAServiceAuth" */
    { 13,  6, 0,  0,    0,  1664 }, /* 0.1.3.6.1.5.5.7.3.13 = "idkpEAPOverPPP" */
    { 14,  6, 0,  0,    0,  1635 }, /* 0.1.3.6.1.5.5.7.3.14 = "idkpEAPOverLAN" */
    {  3,  2, 0,  1,  123,   241 }, /* 0.1.3.14.3 = "oiwssig" */
    {  2,  3, 0,  8,  124,  2049 }, /* 0.1.3.14.3.2 = "oiwssigalgorithms" */
    {  2,  5, 0,  0,    0,  1688 }, /* 0.1.3.14.3.2.2 = "oiwssigMd4WithRsa" */
    {  3,  5, 0,  0,    0,  1588 }, /* 0.1.3.14.3.2.3 = "oiwssigMd5WithRsa" */
    {  4,  6, 0,  0,    0,  1688 }, /* 0.1.3.14.3.2.4 = "oiwssigMd4WithRsaEncryption" */
    { 15, 22, 0,  0,    0,   241 }, /* 0.1.3.14.3.2.15 = "oiwssigShaWithRsaEncryption" */
    { 24,  6, 0,  0,    0,  1594 }, /* 0.1.3.14.3.2.24 = "oiwssigMd2WithRsaEncryption" */
    { 25,  6, 0,  0,    0,  1588 }, /* 0.1.3.14.3.2.25 = "oiwssigMd5WithRsaEncryption" */
    { 26,  3, 0,  0,    0,  1564 }, /* 0.1.3.14.3.2.26 = "oiwssigSha1" */
    { 29,  6, 0,  0,    0,  1564 }, /* 0.1.3.14.3.2.29 = "oiwssigSha1WithRsaEncryption" */
    {  1,  5, 0,  0,    0,  1807 }, /* 0.2.1 = "asn.1" */
    {  5,  1, 0,  2,  135,   401 }, /* 0.2.5 = "x500" */
    { 16, 10, 1,  1,    3,  1301 }, /* 0.2.16 = "by-country" */
    {  4, 16, 0,  6,  137,   634 }, /* 0.2.5.4 = "x500attribute-types" */
    { 29,  2, 0, 20,  143,    30 }, /* 0.2.5.29 = "idce" */
    {  3, 11, 0,  0,    0,  1239 }, /* 0.2.5.4.3 = "x500CommonName" */
    {  6, 12, 0,  0,    0,  1103 }, /* 0.2.5.4.6 = "x500CountryName" */
    {  7, 13, 0,  0,    0,   932 }, /* 0.2.5.4.7 = "x500LocalityName" */
    {  8, 19, 0,  0,    0,   401 }, /* 0.2.5.4.8 = "x500StatOrProvinceName" */
    { 10,  3, 0,  0,    0,  2037 }, /* 0.2.5.4.10 = "x500OrganizationName" */
    { 11,  4, 0,  0,    0,  1919 }, /* 0.2.5.4.11 = "x500OrganizationUnitName" */
    {  1,  6, 0,  0,    0,  1570 }, /* 0.2.5.29.1 = "idceAuthorityKeyIdentifierDeprecated" */
    {  2,  5, 0,  0,    0,  1732 }, /* 0.2.5.29.2 = "idceKeyAttributesDeprecated" */
    {  3,  5, 0,  0,    0,  1827 }, /* 0.2.5.29.3 = "idceCertificatePoliciesDeprecated" */
    {  4, 26, 0,  0,    0,    30 }, /* 0.2.5.29.4 = "idceKeyUsageRestriction-Deprecated" */
    {  7,  6, 0,  0,    0,  1582 }, /* 0.2.5.29.7 = "idceSubjectAltNameDeprecated" */
    {  8,  6, 0,  0,    0,  1694 }, /* 0.2.5.29.8 = "idceIssuerAltNameDeprecated" */
    { 14,  5, 0,  0,    0,  1717 }, /* 0.2.5.29.14 = "idceSubjectKeyIdentifier" */
    { 15,  4, 0,  0,    0,    30 }, /* 0.2.5.29.15 = "idceKeyUsage" */
    { 16, 23, 0,  0,    0,   173 }, /* 0.2.5.29.16 = "idcePrivateKeyUsagePeriod" */
    { 17,  5, 0,  0,    0,  1582 }, /* 0.2.5.29.17 = "idceSubjectAltName" */
    { 18, 15, 0,  0,    0,   713 }, /* 0.2.5.29.18 = "idceissuerAltName" */
    { 19, 18, 0,  0,    0,   477 }, /* 0.2.5.29.19 = "idceBasicConstraints" */
    { 25,  5, 0,  0,    0,  1852 }, /* 0.2.5.29.25 = "idceCrlDistributionPoints" */
    { 29,  4, 0,  0,    0,  1971 }, /* 0.2.5.29.29 = "idceCertificateIssuer" */
    { 30,  4, 0,  0,    0,  1891 }, /* 0.2.5.29.30 = "idceNameConstraints" */
    { 31,  5, 0,  0,    0,  1852 }, /* 0.2.5.29.31 = "idceCrlDistributionPoints" */
    { 32,  4, 0,  1,  163,  1827 }, /* 0.2.5.29.32 = "idceCertificatePolicies" */
    { 35,  5, 0,  0,    0,  1570 }, /* 0.2.5.29.35 = "idceAuthorityKeyIdentifier" */
    { 36,  4, 0,  0,    0,  1967 }, /* 0.2.5.29.36 = "idcePolicyConstraints" */
    { 37, 13, 0,  0,    0,   854 }, /* 0.2.5.29.37 = "idceExtKeyUsage" */
    {  0, 12, 0,  0,    0,  1091 }, /* 0.2.5.29.32.0 = "idcecpanyPolicy" */
    {  1,  5, 1,  3,    4,  1752 }, /* 0.2.16.840.1 = "usacompanyarc" */
    {  3, 11, 0,  1,  166,  1151 }, /* 0.2.16.840.1.101.3 = "usacomputersecurityregister" */
    {  4,  2, 0,  2,  167,  2096 }, /* 0.2.16.840.1.101.3.4 = "nistalgorithms" */
    {  1,  3, 0,  0,    0,  1987 }, /* 0.2.16.840.1.101.3.4.1 = "nistaesalgorithms" */
    {  2, 16, 0,  4,  169,   650 }, /* 0.2.16.840.1.101.3.4.2 = "nisthash-algorithms" */
    {  1,  2, 0,  0,    0,  2086 }, /* 0.2.16.840.1.101.3.4.2.1 = "nistSha256" */
    {  2,  2, 0,  0,    0,  2090 }, /* 0.2.16.840.1.101.3.4.2.2 = "nistSha384" */
    {  3,  2, 0,  0,    0,  2088 }, /* 0.2.16.840.1.101.3.4.2.3 = "nistSha512" */
    {  4,  2, 0,  0,    0,  2084 }, /* 0.2.16.840.1.101.3.4.2.4 = "nistSha224" */
    {  1,  0, 0, 11,  175,     0 }, /* 0.2.16.840.1.113730.1 */
    {  4,  0, 0,  1,  186,     0 }, /* 0.2.16.840.1.113730.4 */
    {  1,  3, 0,  0,    0,  2028 }, /* 0.2.16.840.1.113730.1.1 = "netscapecerttype" */
    {  2,  9, 0,  0,    0,  1359 }, /* 0.2.16.840.1.113730.1.2 = "netscapebase-url" */
    {  3,  3, 0,  0,    0,  1996 }, /* 0.2.16.840.1.113730.1.3 = "netscaperevocationurl" */
    {  4,  4, 0,  0,    0,  1927 }, /* 0.2.16.840.1.113730.1.4 = "netscapecarevocationurl" */
    {  7,  4, 0,  0,    0,  1887 }, /* 0.2.16.840.1.113730.1.7 = "netscapecertrenewalurl" */
    {  8,  4, 0,  0,    0,  1899 }, /* 0.2.16.840.1.113730.1.8 = "netscapecapolicyurl" */
    {  9, 13, 0,  0,    0,   958 }, /* 0.2.16.840.1.113730.1.9 = "netscapeHomePage-url" */
    { 10, 11, 0,  0,    0,  1228 }, /* 0.2.16.840.1.113730.1.10 = "netscapeEntityLogo" */
    { 11,  9, 0,  0,    0,  1386 }, /* 0.2.16.840.1.113730.1.11 = "netscapeUserPicture" */
    { 12,  7, 0,  0,    0,  1550 }, /* 0.2.16.840.1.113730.1.12 = "netscapesslservername" */
    { 13,  8, 0,  0,    0,  1455 }, /* 0.2.16.840.1.113730.1.13 = "netscapecomment" */
    {  1, 14, 0,  0,    0,   799 }, /* 0.2.16.840.1.113730.4.1 = "netscapeekuserverGatedCrypto" */
    {  1,  2, 0,  3,  188,   549 }, /* 0.2.16.840.1.113733.1 = "verisignpki" */
    {  6, 12, 0,  1,  191,  1055 }, /* 0.2.16.840.1.113733.1.6 = "verisignpkiextensions" */
    {  7, 10, 0,  5,  192,  1331 }, /* 0.2.16.840.1.113733.1.7 = "verisignpkipolicies" */
    {  8,  0, 0,  1,  205,     0 }, /* 0.2.16.840.1.113733.1.8 */
    {  7, 16, 0,  0,    0,   618 }, /* 0.2.16.840.1.113733.1.6.7 = "verisignpkiext-RolloverID" */
    {  9,  4, 0,  0,    0,  1911 }, /* 0.2.16.840.1.113733.1.7.9 = "verisignpkipolicy9" */
    { 21,  5, 0,  0,    0,  1867 }, /* 0.2.16.840.1.113733.1.7.21 = "verisignpkipolicy21" */
    { 23,  5, 0,  5,  197,  1162 }, /* 0.2.16.840.1.113733.1.7.23 = "verisignpkipolicyvtncp" */
    { 46,  4, 0,  2,  202,  1757 }, /* 0.2.16.840.1.113733.1.7.46 = "verisignpkipolicycis" */
    { 48,  4, 0,  1,  204,  1377 }, /* 0.2.16.840.1.113733.1.7.48 = "verisignpkipolicythawte" */
    {  1, 11, 0,  0,    0,  1217 }, /* 0.2.16.840.1.113733.1.7.23.1 = "verisignpkipolicyvtncpclass1" */
    {  2, 11, 0,  0,    0,  1162 }, /* 0.2.16.840.1.113733.1.7.23.2 = "verisignpkipolicyvtncpclass2" */
    {  3, 11, 0,  0,    0,  1173 }, /* 0.2.16.840.1.113733.1.7.23.3 = "verisignpkipolicyvtncpclass3" */
    {  4, 11, 0,  0,    0,  1184 }, /* 0.2.16.840.1.113733.1.7.23.4 = "verisignpkipolicyvtncpclass4" */
    {  6,  6, 0,  0,    0,  1676 }, /* 0.2.16.840.1.113733.1.7.23.6 = "verisignpkipolicyvtncp6" */
    {  1,  5, 0,  0,    0,  1872 }, /* 0.2.16.840.1.113733.1.7.46.1 = "verisignpkipolicycistype1" */
    {  2,  5, 0,  0,    0,  1757 }, /* 0.2.16.840.1.113733.1.7.46.2 = "verisignpkipolicycistype2" */
    {  1,  9, 0,  0,    0,  1377 }, /* 0.2.16.840.1.113733.1.7.48.1 = "verisignpkipolicythawtecps-1" */
    {  1, 18, 0,  0,    0,   549 }, /* 0.2.16.840.1.113733.1.8.1 = "verisignpkiekuIssStrongCrypto" */
};

#if defined(RT_ARCH_AMD64) || defined(RT_ARCH_X86)
# pragma pack(2)
#endif
typedef struct RTOIDENTRYBIG
{
    uint32_t    uKey;
    uint8_t     cchString;
    uint8_t     fBigTable  : 1;
    uint8_t     cChildren  : 7;
    uint16_t    idxChildren;
    uint16_t    offString;
} RTOIDENTRYBIG;
#if defined(RT_ARCH_AMD64) || defined(RT_ARCH_X86)
# pragma pack()
AssertCompileSize(RTOIDENTRYBIG, 10);
#endif
typedef RTOIDENTRYBIG const *PCRTOIDENTRYBIG;

static const RTOIDENTRYBIG g_aBigOidTable[] = 
{
    {     840,  1, 1,  1,    1,  1151 }, /* 0.1.2.840 = "usa" */
    {  113549,  1, 0,  1,    4,  2098 }, /* 0.1.2.840.113549 = "rsadsi" */
    {     311,  1, 0,  5,   42,  2099 }, /* 0.1.3.6.1.4.1.311 = "microsoft" */
    {     840,  1, 0,  1,  164,  1151 }, /* 0.2.16.840 = "usa" */
    {     101, 10, 0,  1,  165,  1291 }, /* 0.2.16.840.1.101 = "usagoverment" */
    {  113730,  1, 0,  2,  173,   799 }, /* 0.2.16.840.1.113730 = "netscape" */
    {  113733,  1, 0,  1,  187,   549 }, /* 0.2.16.840.1.113733 = "verisign" */
};
